## ros-melodic-xacro 1.13.9

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(xacro)

find_package(catkin REQUIRED COMPONENTS roslint)

catkin_package(
  CFG_EXTRAS xacro-extras.cmake
)

## Uncomment this if the package has a setup.py. This macro ensures
## modules and global scripts declared therein get installed
## See http://ros.org/doc/api/catkin/html/user_guide/setup_dot_py.html
catkin_python_setup()

catkin_install_python(PROGRAMS scripts/xacro
  DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

## For backwards compatibility we also install as xacro.py
#  The roslaunch $(find ...) expects the script to be in the package directory, 
#  and in catkin the package direcory is /share.
install(PROGRAMS xacro.py DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

if(CATKIN_ENABLE_TESTING)
  ## Add folders to be run by python nosetests
  catkin_add_nosetests(test)
  ## add tests for xacro's cmake functions
  add_subdirectory(test)
endif()

roslint_python()

=== test/test-xacro-cmake/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(xacro-test)

find_package(catkin REQUIRED COMPONENTS xacro)

catkin_package()

## manual usage of eval
xacro_add_xacro_file(../include1.xml manual1.xml)
list(APPEND xacro_outputs ${XACRO_OUTPUT_FILE})

xacro_add_xacro_file(../include2.xml manual2.xml OUTPUT MY_OUTPUT_VAR)
list(APPEND xacro_outputs ${MY_OUTPUT_VAR})

add_custom_target(xacro_target ALL DEPENDS ${xacro_outputs})
xacro_install(xacro_target ${xacro_outputs} DESTINATION xml)

## convenience function
xacro_add_files(TARGET xacro test.xacro REMAP bar:=foo foo:=bar INSTALL)

=== debian/changelog ===
ros-melodic-xacro (1.13.9-1stretch) stretch; urgency=high

  * [fix] yaml loading: recursively wrap lists and dicts for dotted dict access (#258 <https://github.com/ros/xacro/issues/258>)
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Mon, 12 Oct 2020 22:00:00 -0000

ros-melodic-xacro (1.13.8-1stretch) stretch; urgency=high

  * Provide support for yaml constructors !degrees and !radians (#252 <https://github.com/ros/xacro/issues/252>)
  * Contributors: Robert Haschke, G.A. vd. Hoorn

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Thu, 27 Aug 2020 22:00:00 -0000

ros-melodic-xacro (1.13.7-1stretch) stretch; urgency=high

  * [fix] Rework YamlDictWrapper to restore dict properties (#250 <https://github.com/ros/xacro/issues/250>)
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Sat, 08 Aug 2020 22:00:00 -0000

ros-melodic-xacro (1.13.6-1stretch) stretch; urgency=high

  * [feature] Improve warnings
    - Unify meaning of verbosity > 0 (to print file location)
    - Provide file location on warning in check_attrs()
    - Issue warning on child elements of <xacro:include> tag
  * [feature] Allow dotted access to yaml-loaded dicts: d.key1.key2.key3 (#245 <https://github.com/ros/xacro/issues/245>)
  * [maint]   Travis: Update distro to Bionic
  * Contributors: Robert Haschke, G.A. vd. Hoorn

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Sat, 04 Jul 2020 22:00:00 -0000

ros-melodic-xacro (1.13.5-1stretch) stretch; urgency=high

  * [feature] Expose abs_filename() (#220 <https://github.com/ros/xacro/issues/220>)
  * [feature] Catch missing closing brace in $() and ${} expressions
  * [maintanence]
    - Replace deprecated yaml.load() -> yaml.safe_load()
    - Save macro names internally w/o 'xacro:' prefix
    - Correctly issue deprecation warning for non-prefixed xacro tags
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Sat, 07 Dec 2019 23:00:00 -0000

ros-melodic-xacro (1.13.4-1stretch) stretch; urgency=high

  * [feature] remove xmlns:xacro from processed file (#207 <https://github.com/ros/xacro/issues/207>)
    - Remove all notions of xmlns:xacro from the resulting document.
    - If the root node defines a xacro:targetNamespace attribute, this will become the global xmlns namespace of the resulting document.
  * [feature] Add len() to allowed python functions (#208 <https://github.com/ros/xacro/issues/208>)
  * [maintanence]
    - --in-order warning: reduce severity level to message
    - fix and cleanup test of cmake extensions
    - adapt run_xacro() to run xacro from PATH
    - simplify import of substition_args
    - remove 'requires' field from setup.py
    - fix Travis config: use new repository key, use xenial/kinetic distro
    - basic README.md
    - fix catkin_lint issue
    - remove duplicate catkin_python_setup() (#206 <https://github.com/ros/xacro/issues/206>)
  * Contributors: Robert Haschke, James Xu, Martin Pecka

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Wed, 25 Sep 2019 22:00:00 -0000

ros-melodic-xacro (1.13.3-1stretch) stretch; urgency=high

  * use INORDER as default in cmake functions
  * remove weird 'None's in error messages
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Sat, 13 Oct 2018 22:00:00 -0000

ros-melodic-xacro (1.13.2-1stretch) stretch; urgency=high

  * deprecate --includes option (which is tied to deprecated --legacy processing)
  * moved all option handling to cli.py, including deprecation warnings for options
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Sun, 13 May 2018 22:00:00 -0000

ros-melodic-xacro (1.13.1-1stretch) stretch; urgency=high

  * fix parsing of quoted strings in default args for xacro params (#187 <https://github.com/ros/xacro/issues/187>)
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Wed, 02 May 2018 22:00:00 -0000

ros-melodic-xacro (1.13.0-1stretch) stretch; urgency=high

  * make --inorder processing the default
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Fri, 30 Mar 2018 22:00:00 -0000

ros-melodic-xacro (1.12.1-1stretch) stretch; urgency=high

  * #183 <https://github.com/ros/xacro/issues/183>: unicode support for python2 and python3
  * #178 <https://github.com/ros/xacro/issues/178>: extend list of allowed python builtins: min, max, round
  * #182 <https://github.com/ros/xacro/issues/182>: suppress xacro warnings when determining dependencies
  * #151 <https://github.com/ros/xacro/issues/151>: fixes for #149 <https://github.com/ros/xacro/issues/149> and #148 <https://github.com/ros/xacro/issues/148>
  * #157 <https://github.com/ros/xacro/issues/157>: fix #156 <https://github.com/ros/xacro/issues/156> access to undefined target_table
  * #150 <https://github.com/ros/xacro/issues/150>: allow True/False literals in python expressions
  * #159 <https://github.com/ros/xacro/issues/159>: load ROS-related packages on demand, thus becoming more independent from ROS
  * #173 <https://github.com/ros/xacro/issues/173>: allow default values for properties
  * #172 <https://github.com/ros/xacro/issues/172>: fix formatting of XacroException
  * #171 <https://github.com/ros/xacro/issues/171>: fix dependency handling (--deps option)
  * #163 <https://github.com/ros/xacro/issues/163>: full python 3 compatibility
  * Contributors: Robert Haschke, Kartik Mohta, Morgan Quigley, Steven Peters

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Tue, 27 Mar 2018 22:00:00 -0000

ros-melodic-xacro (1.12.0-1stretch) stretch; urgency=high



 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Fri, 24 Mar 2017 23:00:00 -0000

ros-melodic-xacro (1.11.2-1stretch) stretch; urgency=high

  * Convert exception to string in a python2/3 compatible way.
  * Use python2/3 independent check for file type.


=== debian/control ===
Source: ros-melodic-xacro
Section: misc
Priority: optional
Maintainer: Robert Haschke <rhaschke@techfak.uni-bielefeld.de>
Build-Depends: debhelper (>= 9.0.0), ros-melodic-catkin (>= 0.5.68), ros-melodic-roslint, ros-melodic-rostest
Homepage: http://ros.org/wiki/xacro
Standards-Version: 3.9.2

Package: ros-melodic-xacro
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-roslaunch
Description: Xacro (XML Macros) Xacro is an XML macro language.
 With xacro, you can construct shorter and more readable XML files by using macros that expand to larger XML expressions.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-xacro//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install

## ros-melodic-xacro 1.13.20

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,7 +16,7 @@
   DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})
 
 ## For backwards compatibility we also install as xacro.py
-#  The roslaunch $(find ...) expects the script to be in the package directory, 
+#  The roslaunch $(find ...) expects the script to be in the package directory,
 #  and in catkin the package direcory is /share.
 install(PROGRAMS xacro.py DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

=== debian/changelog ===
ros-melodic-xacro (1.13.20-1bionic) bionic; urgency=high

  * Fix hasattr support of YamlDictWrapper (#324 <https://github.com/ros/xacro/issues/324>)
  * Contributors: Alec Tiefenthal

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Tue, 23 May 2023 22:00:00 -0000

ros-melodic-xacro (1.13.19-1bionic) bionic; urgency=high

  * Evaluate ``arg`` value as str/unicode (#322 <https://github.com/ros/xacro/issues/322>)
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Sun, 26 Feb 2023 23:00:00 -0000

ros-melodic-xacro (1.13.18-1bionic) bionic; urgency=high

  * Dotted YAML access from list iterator (#318 <https://github.com/ros/xacro/issues/318>)
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Thu, 20 Oct 2022 22:00:00 -0000

ros-melodic-xacro (1.13.17-1bionic) bionic; urgency=high

  * Only optionally activate comment evaluation (#310 <https://github.com/ros/xacro/issues/310>)Comment evaluation can be enabled with a special comment:
    
      * ``<!-- xacro:eval-comments -->`` or
      * ``<!-- xacro:eval-comments:on -->``
    It remains active for the following comments until:
    
      * the current XML tag's scope is left (or a new tag entered)
      * another tag or non-whitespace text is processed
      * it becomes explicitly disabled via: ``<!-- xacro:eval-comments:off -->``
    
  * Fix property resolution with namespace usage (#308 <https://github.com/ros/xacro/issues/308>)
    
      * Allow access to properties in parent scopes again (fixes #305 <https://github.com/ros/xacro/issues/305#issuecomment-1016811150>)
      * Pick correct scope when defining a property into the parent (fixes #307 <https://github.com/ros/xacro/issues/307>)Setting a property within the parent scope may occur in two contexts:From within a macro. In that case, one wants to set the property in the caller's scope.
        
        From within the included file. In that case, one wants to set the property in the includer's scope.
    
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Fri, 11 Feb 2022 23:00:00 -0000

ros-melodic-xacro (1.13.16-1bionic) bionic; urgency=high

  * Issue a warning only for evaluation errors in comments
  * Add LICENSE file
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Sat, 29 Jan 2022 23:00:00 -0000

ros-melodic-xacro (1.13.15-1bionic) bionic; urgency=high

  * Fix resolving of macros and properties declared and used in/from a namespace (#297 <https://github.com/ros/xacro/issues/297>, #306 <https://github.com/ros/xacro/issues/306>)Macros and properties that are declared within a namespaced include shouldn't require the namespace prefix when used within the namespace.
  * Perform expression evaluation in comments (#300 <https://github.com/ros/xacro/issues/300>)
  * Expose xacro.arg() to facilitate access to substitution args
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Wed, 19 Jan 2022 23:00:00 -0000

ros-melodic-xacro (1.13.14-1bionic) bionic; urgency=high

  * Allow property names to be evaluated from an expression
    This allows to turn macros into a function that can compute an arbitrary property:
    
        <xacro:macro name="square" params="name args">
      <!-- Perform some complex computation and set the property within the parent's scope -->
      <xacro:property name="${name}" value="${[float(x)**2 for x in args]}" scope="parent" />
    </xacro:macro>
    <xacro:square name="result" args="${python.range(5)}" />
    
  * Fix error reporting for invalid symbols in NameSpaces
  * Allow removal of a property definition (#288 <https://github.com/ros/xacro/issues/288>)<xacro:property name="prop" remove="true"/>
  * Allow greedy property evaluation (#284 <https://github.com/ros/xacro/issues/284>)
    This can be used, to redefine a property from its previous value, e.g. for normalization:
    
        <xacro:property name="prop" value="${prop.lower()}" lazy_eval="false"/>
    
  * Correctly expose XML namespaces imported via ``xacro:include`` within a macro (#287 <https://github.com/ros/xacro/issues/287>)
  * Throw when attempting to declare a property starting with *double* underscore (#286 <https://github.com/ros/xacro/issues/286>)
  * Improve global symbols (#283 <https://github.com/ros/xacro/issues/283>)
    
      * Expose most builtin symbols of python
      * Expose xacro functions into ``xacro`` namespace
        
          * ``xacro.print_location()`` to print the current filestack
          * ``tokenize(string, sep=',; ', skip_empty=True)`` to facilitate string tokenization
          * ``message()``, ``warning()``, ``error()``, and ``fatal()`` to output messages on ``stderr``.
            All but ``message()`` print the error location (macro call and file hierarchy) by default:
            
                ${xacro.message('message', 'text', 2, 3.14, color=32, print_location=True)}
            ${xacro.warning('warning')}
            ${xacro.error('error', print_location=False)}
            ${xacro.fatal('fatal')}
            
        
      * Rework handling of file and macro stack, such that print_location() works from anywhere
      * Unit tests: Reduce reported ``stdout``/``stderr`` output
      * Rework definition of ``global_symbols`` to expose functions into namespaces python, math, xacro
    
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Fri, 01 Oct 2021 22:00:00 -0000

ros-melodic-xacro (1.13.13-1bionic) bionic; urgency=high

  * Allow more builtin symbols: sorted, set
  * Don't import hidden symbols from math package
  * Fix ``eval()`` security vulnerability
    
      * ``safe_eval()``: Forbid symbol names starting with *double* underscore
      * unit tests validating the protection mechanism
    
  * Generalize yaml ``!degrees`` constructor: Enable expressions as well


=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: misc
 Priority: optional
 Maintainer: Robert Haschke <rhaschke@techfak.uni-bielefeld.de>
-Build-Depends: debhelper (>= 9.0.0), ros-melodic-catkin (>= 0.5.68), ros-melodic-roslint, ros-melodic-rostest
+Build-Depends: debhelper (>= 9.0.0), ros-melodic-catkin (>= 0.5.68), ros-melodic-roslint, ros-melodic-rostest <!nocheck>
 Homepage: http://ros.org/wiki/xacro
 Standards-Version: 3.9.2

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"
+		-DCMAKE_PREFIX_PATH="/opt/ros/melodic" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
